package com.fr.plugin.event.manager.data;

import com.fr.design.designer.creator.XCreator;
import com.fr.design.designer.creator.XCreatorUtils;
import com.fr.form.ui.Widget;

import javax.swing.Icon;

/**
 * 树的节点，包含一个控件对象
 * 因为树节点可能是纯目录型的，比如sheet,block，也可能是带有控件的
 * @author Joe
 * Created by Joe on 12/14/2020
 */
public class MyWidget extends MyNode {
    private XCreator creator;

    // 是否含有事件
    private boolean hasEvent = false;

    public MyWidget(XCreator creator) {
        this.creator = creator;
        this.nodeName = creator.toData().getWidgetName();
        this.icon = XCreatorUtils.getCreatorIcon(creator);
    }

    public MyWidget(Widget widget) {
        creator = XCreatorUtils.createXCreator(widget);
        this.nodeName = widget.getWidgetName();
        this.icon = XCreatorUtils.getCreatorIcon(creator);
    }

    public XCreator getCreator() {
        return creator;
    }

    public void setCreator(XCreator creator) {
        this.creator = creator;
    }

    public boolean isHasEvent() {
        return hasEvent;
    }

    public void setHasEvent(boolean hasEvent) {
        this.hasEvent = hasEvent;
    }

    public Widget getWidget() {
        return creator.toData();
    }
}
