package com.fr.plugin.event.manager.ui;

import com.fr.design.gui.frpane.LoadingBasicPane;

import javax.swing.JPanel;

/**
 * 普通报表和表单事件管理器面板的父类
 * @author Joe
 * Created by Joe on 12/11/2020
 */
public abstract class EventManagerPane<T> extends LoadingBasicPane {
    protected EventConfigPane eventConfigPane;
    private T target;

    /**
     * 模板方法
     *
     * @param container
     */
    @Override
    protected void initComponents(JPanel container) {
        initData(target);
        createComponents(container);
    }

    /**
     * 初始化数据
     *
     * @param target
     */
    protected abstract void initData(T target);

    /**
     * 初始化面板
     *
     * @param container
     */
    protected abstract void createComponents(JPanel container);

    public void setTarget(T target) {
        this.target = target;
    }

    @Override
    protected String title4PopupWindow() {
        return com.fr.design.i18n.Toolkit.i18nText("Fine-Plugin_Event_Manager_Title");
    }

    public void update() {
        eventConfigPane.update();
    }

}
